package com.javacodegeeks;


import net.sf.saxon.om.NamespaceConstant;
import org.w3c.dom.Document;
import org.w3c.dom.NodeList;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathFactory;

/**
 * Example to use XPath 'ends-with' function.
 * @author JavaCodeGeeks
 */
public class ExampleXPathEndsWith {

    public static final String XPATH_EXPRESSION = "//User/Address/Country[ends-with(text(), \"Kingdom\")]";
    private DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();
    private DocumentBuilder builder = null;

    public static void main(String q[]) {
        ExampleXPathEndsWith exampleXPathEndsWith = new ExampleXPathEndsWith();
        exampleXPathEndsWith.execute();
    }

    private void execute() {
        try{
            System.setProperty("javax.xml.xpath.XPathFactory:"+ NamespaceConstant.OBJECT_MODEL_SAXON, "net.sf.saxon.xpath.XPathFactoryImpl");
            XPathFactory factory = XPathFactory.newInstance(NamespaceConstant.OBJECT_MODEL_SAXON);
            builder = builderFactory.newDocumentBuilder();
            Document document = builder.parse(this.getClass().getResourceAsStream("/user.xml"));

            XPath xpath = factory.newXPath();
            XPathExpression expr = xpath.compile(XPATH_EXPRESSION);
            Object result = expr.evaluate(document, XPathConstants.NODESET);
            NodeList nodes = (NodeList) result;
            System.out.println(nodes.item(0).getTextContent());
        }
        catch(Exception e){
            e.printStackTrace();
        }
    }
}
